powerline/tests/test_shells/test.sh

65 lines
1.5 KiB
Bash
Raw Normal View History

2014-01-11 10:16:25 +01:00
#!/bin/sh
FAILED=0
2014-01-11 10:16:25 +01:00
if [ "$(echo '\e')" != '\e' ] ; then
safe_echo() {
echo -E "$@"
}
else
safe_echo() {
echo "$@"
}
fi
check_screen_log() {
diff -u tests/test_shells/${1}.ok tests/shell/screen.log
# Explicit is better then implicit
return $?
}
2014-01-12 21:53:38 +01:00
run_test() {
SH="$1"
2014-01-12 21:53:38 +01:00
SESNAME="powerline-shell-test-$$"
screen -L -c tests/test_shells/screenrc -d -m -S "$SESNAME" \
2014-01-13 16:47:58 +01:00
env LANG=en_US.UTF-8 BINDFILE="$BINDFILE" "$@"
screen -S "$SESNAME" -X readreg a tests/test_shells/input.$SH
# Wait for screen to initialize
sleep 0.3s
2014-01-12 21:53:38 +01:00
screen -S "$SESNAME" -p 0 -X width 300 1
screen -S "$SESNAME" -p 0 -X logfile tests/shell/screen.log
screen -S "$SESNAME" -p 0 -X paste a
# Wait for screen to exit (sending command to non-existing screen session
# fails; when launched instance exits corresponding session is deleted)
2014-01-12 21:53:38 +01:00
while screen -S "$SESNAME" -X blankerprg "" > /dev/null ; do
sleep 0.1s
2014-01-12 21:53:38 +01:00
done
./tests/test_shells/postproc.py tests/shell/screen.log
if ! check_screen_log ${SH} ; then
# Repeat the diff to make it better viewable in travis output
check_screen_log ${SH} | cat -v
2014-01-12 21:53:38 +01:00
return 1
fi
return 0
2014-01-11 10:36:02 +01:00
}
2014-01-11 10:16:25 +01:00
mkdir tests/shell
git init tests/shell/3rd
git --git-dir=tests/shell/3rd/.git checkout -b BRANCH
2014-01-12 21:53:38 +01:00
if ! run_test bash --norc --noprofile -i ; then
echo "Failed bash"
2014-01-11 10:16:25 +01:00
FAILED=1
fi
cp tests/shell/screen.log tests/bash.log
rm tests/shell/screen.log
2014-01-13 16:47:58 +01:00
if ! run_test zsh -f -i ; then
echo "Failed zsh"
FAILED=1
fi
cp tests/shell/screen.log tests/zsh.log
2014-01-13 16:47:58 +01:00
rm tests/shell/screen.log
2014-01-11 10:16:25 +01:00
rm -r tests/shell
exit $FAILED